/*
   program: upperLink.rex
   date:    97-11-28
   version: 1.1
   changed: 97-12-04, ---rgf, using symbolic links rather than hard-links
           2005-05-28, ---rgf, renamed from .cmd to .rex, uppercased filename in ::requires for ..IX-systems
   author:  ---rgf
   purpose: create symbolic links to Rexx-programs using the uppercase version of the filename or
            remove uppercased symbolic links to files
*/

PARSE ARG pattern '/' flag rest

say "arg(1)" pp( arg(1) )
say "pattern" pp( pattern ) "flag" pp( flag ) "rest" pp( flag )

bRemoveSLink = .false

IF flag <> "" THEN      /* remove symbolic links ?      */
DO
   bRemoveSLink = (TRANSLATE( LEFT( flag, 1 ) ) = "R")
   IF pattern = "" THEN pattern = rest
say "bRemoveSLink" pp( bRemoveSLink ) "pattern" pp( pattern )
say 
END
ELSE
   IF flag <> ""   THEN PARSE ARG pattern       


IF bRemoveSLink THEN
DO
   IF pattern = "" THEN pattern = "*REX"   /* default */
   CALL SysFileTree pattern, "files.", "F"
END
ELSE
DO
   IF pattern = "" THEN pattern = "*rex"   /* default */
   CALL SysFileTree pattern, "files.", "FO"
END

SAY "bRemoveSLink" pp( bRemoveSLink ) "pattern" pp( pattern )
SAY "nr. of files:" pp( files.0 )

length = LENGTH( files.0 )              /* get width of maximum number      */

i0 = 0                                  /* count found symbolic links   */
IF bRemoveSLink THEN
DO i = 1 TO files.0
   PARSE VAR files.i . . . flags fname
   fname = STRIP( fname )
/*
say pp( files.i )
say pp( flags ) pp( fname )
*/
   IF fname <> TRANSLATE( fname ) THEN ITERATE  /* only remove slinks in all uppercase */

   IF LEFT( flags, 1 ) = "l" THEN       /* symbolic link found  */
   DO
      i0 = i0 + 1
      SAY RIGHT( i, length ) "- rm slink" pp( fname ) "..."
      befehl = "rm" fname               /* remove symbolic link         */
/*
      SAY LEFT( "", length ) " " pp( befehl )
*/
      befehl
   END
END
ELSE                    /* create symbolic links with uppercase names   */
DO i = 1 TO files.0
   befehl = ""                          /* make sure command is empty       */
   tmpUpper = TRANSLATE( files.i )      /* uppercase filename   */

   IF tmpUpper <> files.i THEN          /* differ, create link  */
   DO
      IF STREAM( tmpUpper, "C", "QUERY EXISTS" ) = "" THEN
         befehl = "ln -s" files.i tmpUpper  /* link lower/mix-case to uppercase */
   END

   SAY RIGHT( i, length ) "-" pp( files.i )
   IF befehl <> "" THEN
   DO
      SAY LEFT( "", length ) " " pp( befehl )
      befehl
   END
END

EXIT 0


PP : RETURN "[" || ARG( 1 ) || "]"      /* raw pretty print     */

